#include "misc.h"

void static_init()
{
    unsigned short *tex;
    int x,y;
    int r;
    int i;

    static_tex = ta->txr_allocate(512*512*2);
    tex = ta->txr_map(static_tex);
    memset(tex, 0, 512*512*2);

    for(y=0; y<512; y++) {
	for(x=0; x<496; x+=31) {
	    r = rand();
	    for(i=0; i<31; i++) {
		tex[x+i+512*y] = (r&1) * 0xffff;
		r = r>>1;
	    }
	}
	r = rand();
	for(x=496; x<512; x++) {
	    tex[x+512*y] = (r&1) * 0xffff;
	    r = r>>1;
	}	
    }	
}

float static_uv[16][2] = {
    {0.0, 0.0},
    {0.5, 0.0},
    {0.0, 0.5},
    {0.5, 0.5},

    {0.5, 0.0},
    {1.0, 0.0},
    {0.5, 0.5},
    {1.0, 0.5},

    {0.0, 0.5},
    {0.5, 0.5},
    {0.0, 1.0},
    {0.5, 1.0},

    {0.5, 0.5},
    {1.0, 0.5},
    {0.5, 1.0},
    {1.0, 1.0}};

int uvset = 0;

float static_height = 239;
float old_static_height = 240;

void static_one_frame()
{
    poly_hdr_t poly;
    vertex_ot_t vert;
    float new;
    
    ta->poly_hdr_txr(&poly, TA_OPAQUE, TA_RGB565, 512, 512, static_tex, TA_BILINEAR_FILTER);
    ta->commit_poly_hdr(&poly);
    
    vert.r = vert.g = vert.b = vert.a = 0.8f;
    vert.oa = vert.or = vert.ob = 0.0f;
    vert.flags = TA_VERTEX_NORMAL;
    
    vert.x = 1;
    vert.y = 1 + static_height;
    vert.z = 0.01001f;
    vert.u = static_uv[0+uvset][0] + randnum(100)/1000.0;
    vert.v = static_uv[0+uvset][1] + randnum(100)/1000.0;
    ta->commit_vertex(&vert, sizeof(vert));
    
    vert.x = 640;
    vert.y = 1 + static_height;
    vert.z = 0.01001f;
    vert.u = static_uv[1+uvset][0] + randnum(100)/1000.0;
    vert.v = static_uv[1+uvset][1] + randnum(100)/1000.0;
    ta->commit_vertex(&vert, sizeof(vert));
    
    vert.x = 1;
    vert.y = 480 - static_height;
    vert.z = 0.01001f;
    vert.u = static_uv[2+uvset][0] + randnum(100)/1000.0;
    vert.v = static_uv[2+uvset][1] + randnum(100)/1000.0;
    ta->commit_vertex(&vert, sizeof(vert));
    
    vert.x = 640;
    vert.y = 480 - static_height;
    vert.z = 0.01001f;
    vert.u = static_uv[3+uvset][0] + randnum(100)/1000.0;
    vert.v = static_uv[3+uvset][1] + randnum(100)/1000.0;
    vert.flags = TA_VERTEX_EOL;
    ta->commit_vertex(&vert, sizeof(vert));

    uvset+=4;
    uvset = uvset%16;

    if (static_height > 0)
    {
	new = static_height - (old_static_height - static_height) * 1.5;
	old_static_height = static_height;
	static_height = new;
    }	
    if (static_height < 0)
	static_height = 0;
}
